TemporalOMScalingIcon (OpenMap API)
Date: 2016-12-09

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.bbn.openmap.omGraphics.time
Class TemporalOMScalingIcon

    java.lang.Object
      com.bbn.openmap.omGraphics.geom.BasicGeometry
          com.bbn.openmap.omGraphics.OMGraphicAdapter
              com.bbn.openmap.omGraphics.OMRasterObject
                  com.bbn.openmap.omGraphics.OMRaster
                      com.bbn.openmap.omGraphics.OMScalingRaster
                          com.bbn.openmap.omGraphics.OMScalingIcon
                              com.bbn.openmap.omGraphics.time.TemporalOMScalingIcon

All Implemented Interfaces:
  OMGeometry, OMGraphic, OMGraphicConstants, TemporalOMGraphic, java.awt.image.ImageObserver, java.io.Serializable, java.lang.Cloneable

    public class TemporalOMScalingIcon

extends OMScalingIcon
implements TemporalOMGraphic

See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class com.bbn.openmap.omGraphics.OMRasterObject
`OMRasterObject.TrimScaleFilter`

Field Summary
`protected java.lang.Object` | `id`
`protected boolean` | `interpolate` Flag to indicate that intermediate positions between locations should be interpolated.
`protected TemporalPointSupport` | `timeStamps` A list of points where this point should be.

Fields inherited from class com.bbn.openmap.omGraphics.OMScalingIcon
`baseScale, maxScale, minScale, noScalingRequired`

Fields inherited from class com.bbn.openmap.omGraphics.OMScalingRaster
`clipRect, corners, lastProjection, lat2, lon2, scaleTransformType, scalingXFormOp`

Fields inherited from class com.bbn.openmap.omGraphics.OMRaster
`colors, transparent`

Fields inherited from class com.bbn.openmap.omGraphics.OMRasterObject
`bitmap, bits, colorModel, COLORMODEL_DIRECT, COLORMODEL_IMAGEICON, COLORMODEL_INDEXED, DEBUG, FAST_SCALING, filteredHeight, filteredWidth, height, imageFilter, lat, logger, lon, needToReposition, pixels, point1, point2, renderRotationAngle, rotationAngle, SMOOTH_SCALING, width, x, y`

Fields inherited from class com.bbn.openmap.omGraphics.OMGraphicAdapter
`declutterType, displayPaint, edgeMatchesFill, fillPaint, hasLabel, linePaint, matted, mattingPaint, renderType, selected, selectPaint, showEditablePalette, stroke, textureMask`

Fields inherited from class com.bbn.openmap.omGraphics.geom.BasicGeometry
`attributes, lineType, needToRegenerate, shape, visible`

Fields inherited from interface com.bbn.openmap.omGraphics.OMGraphicConstants
`ADD_GRAPHIC_MASK, APP_OBJECT, BASIC_STROKE, CHANGE_APPEARANCE, clear, DECIMAL_DEGREES, DECLUTTERTYPE_LINE, DECLUTTERTYPE_MOVE, DECLUTTERTYPE_NONE, DECLUTTERTYPE_SPACE, DEFAULT_ROTATIONANGLE, DELETE_GRAPHIC_MASK, DESELECT_GRAPHIC_MASK, DESELECTALL_GRAPHIC_MASK, GRAPHICTYPE_ARC, GRAPHICTYPE_BITMAP, GRAPHICTYPE_CIRCLE, GRAPHICTYPE_ELLIPSE, GRAPHICTYPE_GRAPHIC, GRAPHICTYPE_GRID, GRAPHICTYPE_LINE, GRAPHICTYPE_POINT, GRAPHICTYPE_POLY, GRAPHICTYPE_RASTER, GRAPHICTYPE_RECTANGLE, GRAPHICTYPE_TEXT, INDEX, INFOLINE, LABEL, LINETYPE_GREATCIRCLE, LINETYPE_RHUMB, LINETYPE_STRAIGHT, LINETYPE_UNKNOWN, LOWER_GRAPHIC_MASK, LOWER_TO_BOTTOM_GRAPHIC_MASK, NO_ROTATE, OMGRAPHIC_ELT, OMGRAPHIC_TYPE_ATTR, RADIANS, RAISE_GRAPHIC_MASK, RAISE_TO_TOP_GRAPHIC_MASK, REMOVABLE, RENDERTYPE_LATLON, RENDERTYPE_OFFSET, RENDERTYPE_UNKNOWN, RENDERTYPE_XY, SELECT_GRAPHIC_MASK, SORT_GRAPHICS_MASK, TOOLTIP, UPDATE_GRAPHIC_MASK, UPDATED`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`TemporalOMScalingIcon(java.lang.Object id, int renderType, boolean interpolate)` Construct a blank TemporalOMScalingIcon, to be filled in with set calls.
`TemporalOMScalingIcon(java.lang.Object id, int renderType, boolean interpolate, java.awt.Image image)` Create a scaling icon that moves.
`TemporalOMScalingIcon(java.lang.Object id, int renderType, boolean interpolate, java.awt.Image ii, float baseScale)` Create an scaling icon that will be moved around.
`TemporalOMScalingIcon(java.lang.Object id, int renderType, boolean interpolate, javax.swing.ImageIcon ii)` Create an scaling icon that will be moved around.
`TemporalOMScalingIcon(java.lang.Object id, int renderType, boolean interpolate, javax.swing.ImageIcon ii, float baseScale)` Create an OMRaster, Lat/Lon placement with an ImageIcon.
`TemporalOMScalingIcon(java.lang.Object id, int renderType, boolean interpolate, int w, int h, byte[] bytes, java.awt.Color[] colorTable, int trans, float baseScale)` Lat/Lon placement with a indexed colormodel, which is using a colortable and a byte array to construct the int[] pixels.
`TemporalOMScalingIcon(java.lang.Object id, int renderType, boolean interpolate, int w, int h, int[] pix, float baseScale)` Creates an TemporalOMScalingIcon from images, Lat/Lon placement with a direct colormodel image.

Method Summary
`void` | `addTimeStamp(TemporalRecord timeStamp)` Add a TimeStamp to the point.
`void` | `clearTimeStamps()` Clear all time stamps.
`void` | `generate(Projection p, long time)` Prepare the ScenarioPoint to be rendered in its position at a certain time.
`java.lang.Object` | `getId()`
`boolean` | `isInterpolate()`
`boolean` | `removeTimeStamp(TemporalRecord timeStamp)` Remove a location at a certain time.
`void` | `setId(java.lang.Object id)`
`void` | `setInterpolate(boolean interpolate)`
`TemporalPoint` | `setPosition(long time)` Given a time, figure out the location.
`boolean` | `thisIsYou(java.lang.Object n)` Checks the internal id against the given one.

Methods inherited from class com.bbn.openmap.omGraphics.OMScalingIcon
`getBaseScale, getMaxScale, getMinScale, isOnMap, position, renderImage, restore, scaleTo, setBaseScale, setMaxScale, setMinScale`

Methods inherited from class com.bbn.openmap.omGraphics.OMScalingRaster
`generate, getClippedRectangle, getImageWarp, getLRLat, getLRLon, getScaleTransformType, getULLat, getULLon, render, rotate, setLRLat, setLRLon, setScaleTransformType, setShape, setULLat, setULLon, updateImageForProjection`

Methods inherited from class com.bbn.openmap.omGraphics.OMRaster
`computePixels, evaluateRotationAngle, getBitmapFromInternalData, getByte, getColors, getPixel, getTransparent, setBits, setByte, setColors, setColors, setImageIcon, setPixel, setTransparent`

Methods inherited from class com.bbn.openmap.omGraphics.OMRasterObject
`adjustShapeForRotation, filterImage, getBits, getColorModel, getFilteredHeight, getFilteredWidth, getHeight, getImage, getImageFilter, getLat, getLon, getMapLocation, getNeedToReposition, getPixels, getRotationAngle, getWidth, getX, getY, hasLineTypeChoice, imageUpdate, regenerate, scaleTo, setColorModel, setHeight, setImage, setImageFilter, setLat, setLon, setNeedToReposition, setPixels, setRotationAngle, setWidth, setX, setY, shouldRenderFill`

Methods inherited from class com.bbn.openmap.omGraphics.OMGraphicAdapter
`clone, deselect, distance, getDeclutterType, getDisplayColor, getDisplayPaint, getEdgeMatchesFill, getFillColor, getFillPaint, getHasLabel, getLineColor, getLinePaint, getMattingPaint, getRenderType, getSelectColor, getSelectPaint, getShowEditablePalette, getStroke, getTextureMask, initLabelingDuringGenerate, isClear, isMatted, isSelected, normalizeDistanceForLineWidth, readStroke, readTextureMask, renderLabel, renderShape, select, setDeclutterType, setEdgeMatchesFill, setFillColor, setFillPaint, setGraphicsColor, setGraphicsForEdge, setGraphicsForFill, setHasLabel, setLabelLocation, setLabelLocation, setLabelLocation, setLabelLocation, setLabelLocation, setLabelLocation, setLabelLocation, setLabelLocation, setLineColor, setLinePaint, setMatted, setMattingPaint, setRenderType, setSelectColor, setSelected, setSelectPaint, setShowEditablePalette, setStroke, setTextureMask, shouldRenderEdge, writeStroke, writeTextureMask`

Methods inherited from class com.bbn.openmap.omGraphics.geom.BasicGeometry
`_distance, appendShapeEdge, appendShapeEdge, appendShapeEdge, appendShapeEdge, clearAttributes, contains, createAttributeMap, createBoxShape, createShape, createShape, describeShapeDetail, describeShapeDetail, distanceToEdge, distanceToEdge, draw, draw, fill, fill, getAppObject, getAttribute, getAttributes, getDescription, getLineType, getNeedToRegenerate, getShape, isRenderable, isRenderable, isVisible, putAttribute, removeAttribute, setAppObject, setAttributes, setLineType, setNeedToRegenerate, setShape, setVisible`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.bbn.openmap.omGraphics.OMGraphic
`clone, deselect, getDeclutterType, getDisplayColor, getDisplayPaint, getFillColor, getFillPaint, getLineColor, getLinePaint, getMattingPaint, getRenderType, getSelectColor, getSelectPaint, getShowEditablePalette, getStroke, getTextureMask, hasLineTypeChoice, isMatted, isSelected, normalizeDistanceForLineWidth, regenerate, renderLabel, select, setDeclutterType, setFillPaint, setGraphicsColor, setGraphicsForEdge, setGraphicsForFill, setLabelLocation, setLabelLocation, setLabelLocation, setLinePaint, setMatted, setMattingPaint, setRenderType, setSelected, setSelectPaint, setShowEditablePalette, setStroke, setTextureMask, shouldRenderEdge, shouldRenderFill`

Methods inherited from interface com.bbn.openmap.omGraphics.OMGeometry
`clearAttributes, contains, distance, distanceToEdge, draw, draw, fill, fill, generate, getAppObject, getAttribute, getAttributes, getDescription, getLineType, getNeedToRegenerate, getShape, isRenderable, isRenderable, isVisible, putAttribute, removeAttribute, render, restore, setAppObject, setAttributes, setLineType, setNeedToRegenerate, setShape, setVisible`

Field Detail

### id

    protected java.lang.Object id

### timeStamps

    protected TemporalPointSupport timeStamps

  A list of points where this point should be.

### interpolate

    protected boolean interpolate

  Flag to indicate that intermediate positions between locations should be interpolated.

Constructor Detail

### TemporalOMScalingIcon

    public TemporalOMScalingIcon(java.lang.Object id,
                                 int renderType,
                                 boolean interpolate)

  Construct a blank TemporalOMScalingIcon, to be filled in with set calls.

### TemporalOMScalingIcon

    public TemporalOMScalingIcon(java.lang.Object id,
                                 int renderType,
                                 boolean interpolate,
                                 int w,
                                 int h,
                                 int[] pix,
                                 float baseScale)

  Creates an TemporalOMScalingIcon from images, Lat/Lon placement with a direct colormodel image.

  Parameters:
    `id` - the id of the TemporalOMScalingIcon
    `renderType` - rendertype of coordinates to be used in moving this around
    `interpolate` - flag to interpolate position between TemporalRecords.
    `w` - width of the image, in pixels.
    `h` - height of the image, in pixels.
    `pix` - color values for the pixels.
    `baseScale` - the scale where the icon will be show regular size.
  See Also:
    `OMRaster.setPixel(int, int, int)`

### TemporalOMScalingIcon

    public TemporalOMScalingIcon(java.lang.Object id,
                                 int renderType,
                                 boolean interpolate,
                                 javax.swing.ImageIcon ii,
                                 float baseScale)

  Create an OMRaster, Lat/Lon placement with an ImageIcon.

  Parameters:
    `id` - the id of the TemporalOMScalingIcon
    `renderType` - rendertype of coordinates to be used in moving this around
    `interpolate` - flag to interpolate position between TemporalRecords.
    `ii` - ImageIcon used for the image.
    `baseScale` - the scale where the icon will be show regular size.

### TemporalOMScalingIcon

    public TemporalOMScalingIcon(java.lang.Object id,
                                 int renderType,
                                 boolean interpolate,
                                 javax.swing.ImageIcon ii)

  Create an scaling icon that will be moved around.

  Parameters:
    `id` - the id of the TemporalOMScalingIcon
    `renderType` - rendertype of coordinates to be used in moving this around
    `interpolate` - flag to interpolate position between TemporalRecords.
    `ii` - ImageIcon used for the image.

### TemporalOMScalingIcon

    public TemporalOMScalingIcon(java.lang.Object id,
                                 int renderType,
                                 boolean interpolate,
                                 java.awt.Image ii,
                                 float baseScale)

  Create an scaling icon that will be moved around.

  Parameters:
    `id` - ID of object.
    `renderType` - the interpreted path between known positions
    `interpolate` - whether the positions between known timestamps should be interpolated.
    `ii` - ImageIcon used for image
    `baseScale` -

### TemporalOMScalingIcon

    public TemporalOMScalingIcon(java.lang.Object id,
                                 int renderType,
                                 boolean interpolate,
                                 java.awt.Image image)

  Create a scaling icon that moves.

  Parameters:
    `id` - ID of icon
    `renderType` - how position will be interpolated between know positions
    `interpolate` - whether position should be interpolated between known positions.
    `image` - java Image to use for icon.

### TemporalOMScalingIcon

    public TemporalOMScalingIcon(java.lang.Object id,
                                 int renderType,
                                 boolean interpolate,
                                 int w,
                                 int h,
                                 byte[] bytes,
                                 java.awt.Color[] colorTable,
                                 int trans,
                                 float baseScale)

  Lat/Lon placement with a indexed colormodel, which is using a colortable and a byte array to construct the int[] pixels.

  Parameters:
    `id` - the id of the TemporalOMScalingIcon
    `renderType` - rendertype of coordinates to be used in moving this around
    `interpolate` - flag to interpolate position between TemporalRecords.
    `w` - width of the image, in pixels.
    `h` - height of the image, in pixels.
    `bytes` - colortable index values for the pixels.
    `colorTable` - color array corresponding to bytes
    `trans` - transparency of image.
    `baseScale` - the scale where the icon will be show regular size.
  See Also:
    `OMRaster.setPixel(int, int, int)`

Method Detail

### getId

    public java.lang.Object getId()

### setId

    public void setId(java.lang.Object id)

### isInterpolate

    public boolean isInterpolate()

### setInterpolate

    public void setInterpolate(boolean interpolate)

### thisIsYou

    public boolean thisIsYou(java.lang.Object n)

  Checks the internal id against the given one.

### addTimeStamp

    public void addTimeStamp(TemporalRecord timeStamp)

  Add a TimeStamp to the point.

  Specified by:
    `addTimeStamp` in interface `TemporalOMGraphic`

### removeTimeStamp

    public boolean removeTimeStamp(TemporalRecord timeStamp)

  Description copied from interface: `TemporalOMGraphic`
  Remove a location at a certain time.

  Specified by:
    `removeTimeStamp` in interface `TemporalOMGraphic`

### clearTimeStamps

    public void clearTimeStamps()

  Description copied from interface: `TemporalOMGraphic`
  Clear all time stamps.

  Specified by:
    `clearTimeStamps` in interface `TemporalOMGraphic`

### setPosition

    public TemporalPoint setPosition(long time)

  Given a time, figure out the location. If the time is before the earliest time or after the latest time, the location will be set to the first or last known location, but the marker will made invisible. If the time is in between the first and last time, the position will be interpolated.

### generate

    public void generate(Projection p,
                         long time)

  Prepare the ScenarioPoint to be rendered in its position at a certain time.

  Specified by:
    `generate` in interface `TemporalOMGraphic`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) BBNT Solutions LLC; See http://openmap.bbn.com/ for details